## golang-github-cloudflare-sidh 1.0+git20190228.d2f0f90

=== Makefile ===
# Constants
MK_FILE_PATH = $(lastword $(MAKEFILE_LIST))
PRJ_DIR      = $(abspath $(dir $(MK_FILE_PATH)))
GOPATH_LOCAL = $(PRJ_DIR)/build
GOPATH_DIR   = github.com/cloudflare/sidh
VENDOR_DIR   = build/vendor
CSHAKE_PKG   ?= github.com/henrydcase/nobs/hash/sha3
TARGETS      = p503 p751 sidh sike
GO           ?= go
GOARCH       ?=
OPTS_GCCGO   ?= -compiler gccgo -O2 -g
OPTS         ?=
OPTS_TAGS    ?= -tags=noasm
NOASM        ?=
# -run="NonExistent" is set to make sure tests are not run before benchmarking
BENCH_OPTS   ?= -bench=. -run="NonExistent"
# whether to be verbose
V            ?= 1

ifeq ($(NOASM),1)
	OPTS+=$(OPTS_TAGS)
endif

ifeq ($(V),1)
	OPTS += -v              # Be verbose
	BENCH_OPTS += -gcflags=-m     # Show results from inlining
endif

all: test
clean:
	rm -rf $(GOPATH_LOCAL)
	rm -rf coverage*.txt

build_env:
	GOPATH=$(GOPATH_LOCAL) $(GO) get $(CSHAKE_PKG)
	mkdir -p $(GOPATH_LOCAL)/src/$(GOPATH_DIR)
	cp -rf internal $(GOPATH_LOCAL)/src/$(GOPATH_DIR)
	cp -rf etc $(GOPATH_LOCAL)/src/$(GOPATH_DIR)

copy-target-%:
	cp -rf $* $(GOPATH_LOCAL)/src/$(GOPATH_DIR)

prep_targets: build_env $(addprefix copy-target-, $(TARGETS))

install-%: prep_targets
	GOPATH=$(GOPATH_LOCAL) GOARCH=$(GOARCH) $(GO) install $(OPTS) $(GOPATH_DIR)/$*

test-%: prep_targets
	GOPATH=$(GOPATH_LOCAL) $(GO) vet $(GOPATH_DIR)/$*
	GOPATH=$(GOPATH_LOCAL) GOARCH=$(GOARCH) $(GO) test $(OPTS) $(GOPATH_DIR)/$*

bench-%: prep_targets
	GOMAXPROCS=1 GOPATH=$(GOPATH_LOCAL) $(GO) test $(OPTS) $(GOPATH_DIR)/$* $(BENCH_OPTS)

cover-%: prep_targets
	GOPATH=$(GOPATH_LOCAL) $(GO) test \
		-race -coverprofile=coverage_$*.txt -covermode=atomic $(OPTS) $(GOPATH_DIR)/$*
	cat coverage_$*.txt >> coverage.txt
	rm coverage_$*.txt

vendor: clean
	mkdir -p $(VENDOR_DIR)/github_com/cloudflare/sidh/
	rsync -a . $(VENDOR_DIR)/github_com/cloudflare/sidh/ \
		--exclude=$(VENDOR_DIR) \
		--exclude=.git          \
		--exclude=.travis.yml   \
		--exclude=README.md     \
		--exclude=Makefile      \
		--exclude=build
	# This swaps all imports with github.com to github_com, so that standard library doesn't
	# try to access external libraries.
	find $(VENDOR_DIR) -type f -iname "*.go" -print0  | xargs -0 sed -i 's/github\.com/github_com/g'

bench:   $(addprefix bench-,   $(TARGETS))
cover:   $(addprefix cover-,   $(TARGETS))
install: $(addprefix install-, $(TARGETS))
test:    $(addprefix test-,    $(TARGETS))

=== debian/changelog ===
golang-github-cloudflare-sidh (1.0+git20190228.d2f0f90-5) unstable; urgency=medium

  * debian/control:
    - For golang-github-cloudflare-sidh-dev add Multi-Arch: foreign

 -- Roger Shimizu <rosh@debian.org>  Sun, 26 Sep 2021 01:18:28 +0900

golang-github-cloudflare-sidh (1.0+git20190228.d2f0f90-4) unstable; urgency=medium

  * Update upstream URL.

 -- Roger Shimizu <rosh@debian.org>  Tue, 30 Jun 2020 03:03:35 +0900

golang-github-cloudflare-sidh (1.0+git20190228.d2f0f90-3) unstable; urgency=medium

  * debian/patches:
    - Add patch to skip test takes too long on reproducible builds.

 -- Roger Shimizu <rosh@debian.org>  Fri, 26 Jun 2020 02:18:27 +0900

golang-github-cloudflare-sidh (1.0+git20190228.d2f0f90-2) unstable; urgency=medium

  * Source only re-upload.

 -- Roger Shimizu <rosh@debian.org>  Thu, 18 Jun 2020 01:28:25 +0900

golang-github-cloudflare-sidh (1.0+git20190228.d2f0f90-1) unstable; urgency=medium

  * Initial release (Closes: #959673)

 -- Roger Shimizu <rosh@debian.org>  Mon, 04 May 2020 01:57:35 +0900

=== debian/control ===
Source: golang-github-cloudflare-sidh
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Roger Shimizu <rosh@debian.org>
Section: devel
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 dh-golang,
 golang-any,
 golang-github-henrydcase-nobs-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-cloudflare-sidh
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-cloudflare-sidh.git
Homepage: https://github.com/cloudflarearchive/sidh
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/cloudflare/sidh

Package: golang-github-cloudflare-sidh-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 golang-github-henrydcase-nobs-dev
Description: Supersingular Isogeny Diffie-Hellman golang library
 Go implementation of (ephemeral) supersingular isogeny Diffie-Hellman
 (SIDH) and supersingular isogeny key exchange (SIKE), as specified in
 SIDH-spec, PQC NIST Submission (http://sike.org/files/SIDH-spec.pdf)
 (Nov 30, 2017).
 .
 Portions of the field arithmetic were ported from the Microsoft
 Research implementation.
 .
 The SIDH package does NOT implement key validation. It means that it
 should only be used for ephemeral DH. Each keypair should be used at
 most once.
 .
 Project provides following packages:
   * p503: P503 field arithmetic
   * p751: P751 field arithmetic
   * sidh: Implementation of SIDH key agreement
   * sike: Implementation of SIKE PKE and KEM, based on sidh package

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := etc

%:
	dh $@ --buildsystem=golang --with=golang

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-cloudflare-sidh-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/cloudflare/sidh/tags .*/v?(\d\S*)\.tar\.gz debian
